/*
 * This class file was automatically generated by ASN1bean (http://www.beanit.com)
 */

package com.beanit.asn1bean.compiler.pedefinitions;

import java.io.IOException;
import java.io.EOFException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.io.UnsupportedEncodingException;
import java.math.BigInteger;
import java.io.Serializable;
import com.beanit.asn1bean.ber.*;
import com.beanit.asn1bean.ber.types.*;
import com.beanit.asn1bean.ber.types.string.*;


public class UICCApplicationParameters implements BerType, Serializable {

	private static final long serialVersionUID = 1L;

	public static final BerTag tag = new BerTag(BerTag.UNIVERSAL_CLASS, BerTag.CONSTRUCTED, 16);

	private byte[] code = null;
	public BerOctetString uiccToolkitApplicationSpecificParametersField = null;
	public BerOctetString uiccAccessApplicationSpecificParametersField = null;
	public BerOctetString uiccAdministrativeAccessApplicationSpecificParametersField = null;
	
	public UICCApplicationParameters() {
	}

	public UICCApplicationParameters(byte[] code) {
		this.code = code;
	}

	public UICCApplicationParameters(BerOctetString uiccToolkitApplicationSpecificParametersField, BerOctetString uiccAccessApplicationSpecificParametersField, BerOctetString uiccAdministrativeAccessApplicationSpecificParametersField) {
		this.uiccToolkitApplicationSpecificParametersField = uiccToolkitApplicationSpecificParametersField;
		this.uiccAccessApplicationSpecificParametersField = uiccAccessApplicationSpecificParametersField;
		this.uiccAdministrativeAccessApplicationSpecificParametersField = uiccAdministrativeAccessApplicationSpecificParametersField;
	}

	@Override public int encode(OutputStream reverseOS) throws IOException {
		return encode(reverseOS, true);
	}

	public int encode(OutputStream reverseOS, boolean withTag) throws IOException {

		if (code != null) {
			reverseOS.write(code);
			if (withTag) {
				return tag.encode(reverseOS) + code.length;
			}
			return code.length;
		}

		int codeLength = 0;
		if (uiccAdministrativeAccessApplicationSpecificParametersField != null) {
			codeLength += uiccAdministrativeAccessApplicationSpecificParametersField.encode(reverseOS, false);
			// write tag: CONTEXT_CLASS, PRIMITIVE, 2
			reverseOS.write(0x82);
			codeLength += 1;
		}
		
		if (uiccAccessApplicationSpecificParametersField != null) {
			codeLength += uiccAccessApplicationSpecificParametersField.encode(reverseOS, false);
			// write tag: CONTEXT_CLASS, PRIMITIVE, 1
			reverseOS.write(0x81);
			codeLength += 1;
		}
		
		if (uiccToolkitApplicationSpecificParametersField != null) {
			codeLength += uiccToolkitApplicationSpecificParametersField.encode(reverseOS, false);
			// write tag: CONTEXT_CLASS, PRIMITIVE, 0
			reverseOS.write(0x80);
			codeLength += 1;
		}
		
		codeLength += BerLength.encodeLength(reverseOS, codeLength);

		if (withTag) {
			codeLength += tag.encode(reverseOS);
		}

		return codeLength;

	}

	@Override public int decode(InputStream is) throws IOException {
		return decode(is, true);
	}

	public int decode(InputStream is, boolean withTag) throws IOException {
		int tlByteCount = 0;
		int vByteCount = 0;
		BerTag berTag = new BerTag();

		if (withTag) {
			tlByteCount += tag.decodeAndCheck(is);
		}

		BerLength length = new BerLength();
		tlByteCount += length.decode(is);
		int lengthVal = length.val;
		if (lengthVal == 0) {
			return tlByteCount;
		}
		vByteCount += berTag.decode(is);

		if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.PRIMITIVE, 0)) {
			uiccToolkitApplicationSpecificParametersField = new BerOctetString();
			vByteCount += uiccToolkitApplicationSpecificParametersField.decode(is, false);
			if (lengthVal >= 0 && vByteCount == lengthVal) {
				return tlByteCount + vByteCount;
			}
			vByteCount += berTag.decode(is);
		}
		
		if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.PRIMITIVE, 1)) {
			uiccAccessApplicationSpecificParametersField = new BerOctetString();
			vByteCount += uiccAccessApplicationSpecificParametersField.decode(is, false);
			if (lengthVal >= 0 && vByteCount == lengthVal) {
				return tlByteCount + vByteCount;
			}
			vByteCount += berTag.decode(is);
		}
		
		if (berTag.equals(BerTag.CONTEXT_CLASS, BerTag.PRIMITIVE, 2)) {
			uiccAdministrativeAccessApplicationSpecificParametersField = new BerOctetString();
			vByteCount += uiccAdministrativeAccessApplicationSpecificParametersField.decode(is, false);
			if (lengthVal >= 0 && vByteCount == lengthVal) {
				return tlByteCount + vByteCount;
			}
			vByteCount += berTag.decode(is);
		}
		
		if (lengthVal < 0) {
			if (!berTag.equals(0, 0, 0)) {
				throw new IOException("Decoded sequence has wrong end of contents octets");
			}
			vByteCount += BerLength.readEocByte(is);
			return tlByteCount + vByteCount;
		}

		throw new IOException("Unexpected end of sequence, length tag: " + lengthVal + ", bytes decoded: " + vByteCount);

	}

	public void encodeAndSave(int encodingSizeGuess) throws IOException {
		ReverseByteArrayOutputStream reverseOS = new ReverseByteArrayOutputStream(encodingSizeGuess);
		encode(reverseOS, false);
		code = reverseOS.getArray();
	}

	@Override public String toString() {
		StringBuilder sb = new StringBuilder();
		appendAsString(sb, 0);
		return sb.toString();
	}

	public void appendAsString(StringBuilder sb, int indentLevel) {

		sb.append("{");
		boolean firstSelectedElement = true;
		if (uiccToolkitApplicationSpecificParametersField != null) {
			sb.append("\n");
			for (int i = 0; i < indentLevel + 1; i++) {
				sb.append("\t");
			}
			sb.append("uiccToolkitApplicationSpecificParametersField: ").append(uiccToolkitApplicationSpecificParametersField);
			firstSelectedElement = false;
		}
		
		if (uiccAccessApplicationSpecificParametersField != null) {
			if (!firstSelectedElement) {
				sb.append(",\n");
			}
			for (int i = 0; i < indentLevel + 1; i++) {
				sb.append("\t");
			}
			sb.append("uiccAccessApplicationSpecificParametersField: ").append(uiccAccessApplicationSpecificParametersField);
			firstSelectedElement = false;
		}
		
		if (uiccAdministrativeAccessApplicationSpecificParametersField != null) {
			if (!firstSelectedElement) {
				sb.append(",\n");
			}
			for (int i = 0; i < indentLevel + 1; i++) {
				sb.append("\t");
			}
			sb.append("uiccAdministrativeAccessApplicationSpecificParametersField: ").append(uiccAdministrativeAccessApplicationSpecificParametersField);
			firstSelectedElement = false;
		}
		
		sb.append("\n");
		for (int i = 0; i < indentLevel; i++) {
			sb.append("\t");
		}
		sb.append("}");
	}

}

